#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 75 "./grammar.y"

#include <symbol.h>
#include <semantic.h>

#define YYMAXDEPTH 150

extern int yylex(void);

/* declaration specifier attributes for the typedef statement currently being
 * scanned
 */
static int cur_decl_spec_flags;

/* pointer to parameter list for the current function definition */
static ParameterList *func_params;

/* A parser semantic action sets this pointer to the current declarator in
 * a function parameter declaration in order to catch any comments following
 * the parameter declaration on the same line.  If the lexer scans a comment
 * and <cur_declarator> is not NULL, then the comment is attached to the
 * declarator.  To ignore subsequent comments, the lexer sets this to NULL
 * after scanning a comment or end of line.
 */
static Declarator *cur_declarator;

/* temporary string buffer */
static char *temp_buf = 0;
static size_t temp_len = 0;

SymbolTable *function_names;	/* table of function names */
SymbolTable *typedef_names;	/* table of typedef names */
SymbolTable *define_names;	/* table of define names */
SymbolTable *type_qualifiers;	/* table of type qualifiers */

/* information about the current input file */
typedef struct {
    char *base_name;		/* base input file name */
    char *file_name;		/* current file name */
    size_t len_file_name;	/* ...its allocated size */
    FILE *file;			/* input file */
    unsigned line_num;		/* current line number in input file */
    FILE *tmp_file;		/* temporary file */
    long begin_comment;		/* tmp file offset after last written ) or ; */
    long end_comment;		/* tmp file offset after last comment */
    boolean convert;		/* if TRUE, convert function definitions */
    boolean changed;		/* TRUE if conversion done in this file */
} IncludeStack;

static IncludeStack *cur_file;	/* current input file */

#include "yyerror.c"

static int haveAnsiParam(void);

/* Flags to enable us to find if a procedure returns a value.
 */
static int return_val,		/* nonzero on BRACES iff return-expression found */
  returned_at;			/* marker for token-number to set 'return_val' */

#if OPT_LINTLIBRARY
static const char *
dft_decl_spec(void)
{
    return (lintLibrary() && !return_val) ? "void" : "int";
}

#else
#define dft_decl_spec() "int"
#endif

static int
haveAnsiParam(void)
{
    Parameter *p;
    if (func_params != 0) {
	for (p = func_params->first; p != 0; p = p->next) {
	    if (p->declarator->func_def == FUNC_ANSI) {
		return TRUE;
	    }
	}
    }
    return FALSE;
}

static void
need_temp(size_t need)
{
    if (need > temp_len) {
	if (need < MAX_TEXT_SIZE)
	    need = MAX_TEXT_SIZE;
	if (need < temp_len * 2)
	    need = temp_len * 2;
	temp_buf = type_realloc(char, temp_buf, need);
	temp_len = need;
    }
}

#line 110 "y.tab.c"
#define STD_TYPENAME 257
#define T_IDENTIFIER 258
#define T_TYPEDEF_NAME 259
#define T_DEFINE_NAME 260
#define T_AUTO 261
#define T_EXTERN 262
#define T_REGISTER 263
#define T_STATIC 264
#define T_TYPEDEF 265
#define T_INLINE 266
#define T_EXTENSION 267
#define T_ATTRIBUTE 268
#define T_CHAR 269
#define T_DOUBLE 270
#define T_FLOAT 271
#define T_INT 272
#define T_VOID 273
#define T_LONG 274
#define T_SHORT 275
#define T_SIGNED 276
#define T_UNSIGNED 277
#define T_ENUM 278
#define T_STRUCT 279
#define T_UNION 280
#define T_Bool 281
#define T_Complex 282
#define T_Imaginary 283
#define T_LONG_DOUBLE 284
#define T_VA_LIST 285
#define T_TYPE_QUALIFIER 286
#define T_BRACKETS 287
#define T_LBRACE 288
#define T_MATCHRBRACE 289
#define T_ELLIPSIS 290
#define T_INITIALIZER 291
#define T_STRING_LITERAL 292
#define T_ASM 293
#define T_ASMARG 294
#define T_VA_DCL 295
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   26,   26,   27,   27,   27,   27,   27,   27,
   27,   32,   30,   30,   28,   28,   35,   28,   33,   33,
   34,   34,   36,   36,   38,   39,   29,   40,   29,   37,
   37,   37,   41,   41,    1,    1,    2,    2,    2,    3,
    3,    3,    3,    3,    3,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    5,    5,    6,    6,    6,   19,   19,    8,
    8,    9,   42,    9,   31,   31,    7,    7,    7,   25,
   23,   23,   10,   10,   11,   11,   11,   11,   11,   20,
   20,   21,   21,   22,   22,   14,   14,   15,   15,   16,
   16,   16,   17,   17,   18,   18,   24,   24,   12,   12,
   12,   13,   13,   13,   13,   13,   13,   13,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    1,    1,    1,    2,
    2,    2,    3,    3,    2,    3,    0,    5,    2,    1,
    0,    1,    1,    3,    0,    0,    7,    0,    5,    0,
    1,    1,    1,    2,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    2,    2,    1,    1,    1,
    3,    1,    0,    4,    2,    3,    3,    2,    2,    1,
    1,    1,    2,    1,    1,    3,    2,    4,    4,    2,
    3,    0,    1,    1,    2,    1,    3,    1,    3,    2,
    2,    1,    0,    1,    1,    3,    1,    2,    1,    2,
    1,    3,    2,    1,    4,    3,    3,    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,   81,    0,   64,   40,    0,   42,
   43,   20,   44,    0,   46,   47,   49,   50,   56,   51,
   52,   53,   54,   80,   68,   69,   57,   58,   59,   48,
   55,   63,    0,    7,    0,    0,   35,   37,   38,   39,
   61,   62,   28,    0,    0,    0,    0,  107,   85,    0,
    0,    3,    5,    6,    8,    9,    0,   10,   11,   82,
    0,   94,    0,    0,  108,    0,   19,   75,    0,   41,
   45,  114,   15,   36,    0,   70,    0,  101,    0,    0,
    0,    0,   87,    0,    0,    0,   66,    0,    0,   78,
    4,   60,    0,   86,   91,   95,    0,   14,   13,  118,
    0,    0,    0,    0,   98,   16,    0,   73,    0,    0,
  113,    0,   31,   33,    0,    0,    0,    0,    0,  105,
   76,   12,   65,   77,    0,    0,  100,  112,  117,    0,
   71,    0,    0,  116,    0,    0,   34,   88,   89,    0,
   23,    0,    0,   97,   99,   74,   26,  115,   29,  106,
   18,    0,    0,   24,   27,
};
short yydgoto[] = {                                      35,
   97,   37,   38,   39,   40,   41,   42,   75,   76,   43,
   44,   78,   79,  103,  104,  105,  118,  119,   46,   47,
   63,   64,   48,   49,   50,   51,   52,   53,   54,   55,
   56,   87,   57,  142,  125,  143,  115,  109,  153,   81,
  116,  132,
};
short yysindex[] = {                                     73,
    2,   34, -242, -196,    0,    0,    0,    0, -272,    0,
    0,    0,    0, -241,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -267,    0,    0,  531,    0,    0,    0,    0,
    0,    0,    0,  -31, -261, -229,   69,    0,    0, -229,
   73,    0,    0,    0,    0,    0,  786,    0,    0,    0,
   -3,    0,   13, -242,    0,  699,    0,    0,  322,    0,
    0,    0,    0,    0,  -34,    0,  -15,    0,  -29,  214,
  637,  730,    0, -243, -232, -223,    0,  -31, -223,    0,
    0,    0,  786,    0,    0,    0,  609,    0,    0,    0,
  359,   29,   30,   38,    0,    0,   34,    0,  637,  569,
    0,  -29,    0,    0, -200,  758,   48,   52,   50,    0,
    0,    0,    0,    0,   34,  -15,    0,    0,    0,  667,
    0, -194, -193,    0,   59, -188,    0,    0,    0, -196,
    0,   44,   60,    0,    0,    0,    0,    0,    0,    0,
    0,   34, -184,    0,    0,
};
short yyrindex[] = {                                    106,
    0,    0,  175,    0,    0,  -38,    0,    0,  109,    0,
    0,    0,    0,  145,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -183,    0,    0,    0,    0,
    0,    0,    0,  439,    0,    0,    0,    0,    0,    0,
  114,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  404,  399,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  282,    0,  -27,   -4,
 -172,   76,    0,    0,    0,    1,    0,  476,   37,    0,
    0,    0,   -7,    0,    0,    0,    0,    0,    0,    0,
  -22,    0,    0,   78,    0,    0,    0,    0, -172,    0,
    0,    9,    0,    0,    0, -168,    0,    0,   80,    0,
    0,    0,    0,    0,   64,   25,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   65,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   16,  -10,    0,    0,    4,    0,    0,    0,   20,   11,
  -32,   61,   49,  -74,    0,    5,    0,    0,    0,  -35,
    0,    0,    8,    0,    0,    0,   77,  -17,    0,    0,
    0,   36,    0,    0,    0,    0,   22,    0,    0,    0,
    0,    0,
};
#define YYTABLESIZE 1072
short yytable[] = {                                      60,
   80,   60,   60,   60,   45,   60,   62,  117,   82,  107,
  110,   65,   61,  111,   88,   36,  111,    7,  102,   66,
   60,  102,   82,   67,  106,   74,   68,   95,    5,   60,
   17,   84,   17,   80,   17,  135,  109,   94,   67,  109,
   67,   67,   67,   32,   67,  108,   77,   88,   98,  110,
  121,   17,  110,   86,    3,   45,  122,   89,   85,   67,
   59,    5,   60,  114,   85,   80,   36,   96,   72,  128,
  129,    4,   93,    2,   79,    3,   79,   79,   79,   61,
   79,  130,   74,   72,  101,   90,   74,  136,  138,  120,
   74,  114,  139,  140,  147,   79,  146,  101,  137,  148,
  149,   99,  151,  152,  155,    1,    4,  126,    2,  102,
    4,  127,    2,    2,    3,   30,  103,  126,   96,   32,
  104,  123,   21,   22,  124,  101,  131,   91,  112,  102,
  133,   34,    0,    0,  145,  141,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  101,   41,  150,   41,    0,
   41,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  154,    0,    0,    0,    0,   41,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,   45,    0,   45,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,    0,    0,    0,
    0,    0,   92,    0,   92,   92,   92,    0,   92,   60,
   60,   60,   60,   60,   60,   60,   82,   60,   60,    0,
   60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
   60,   60,   60,   60,   60,   60,   60,   60,   60,   82,
   17,    4,    0,   69,   60,   83,   82,  111,   67,   67,
   67,   67,   67,   67,   67,  111,   67,   67,    0,   67,
   67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
   67,   67,   67,   67,   67,   67,   67,   67,  109,    0,
   58,    5,   60,   67,   79,   79,   79,   79,   79,   79,
   79,  110,   79,   79,    0,   79,   79,   79,   79,   79,
   79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
   79,   79,   79,   79,    0,   72,    5,   60,    1,   79,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   72,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    4,
    0,   69,  100,    3,    0,   33,   41,   41,   41,   41,
   41,   41,   41,    0,   41,   41,    0,   41,   41,   41,
   41,   41,   41,   41,   41,   41,   41,   41,   41,   41,
   41,   41,   41,   41,   41,   41,    4,    0,   69,    0,
    3,   41,   45,   45,   45,   45,   45,   45,   45,    0,
   45,   45,    0,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   92,   92,    0,    0,   93,   45,   93,   93,
   93,   90,   93,   90,   90,    0,    0,   90,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   92,    0,    0,    0,    0,    0,   92,    0,    0,
    0,    5,   60,    0,    0,    0,    0,    0,    0,   84,
    0,    0,   84,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   84,    0,   84,
   72,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   83,    0,    0,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   83,    0,   83,    0,    0,    0,
   25,   25,   25,   25,   25,   25,   25,   25,   25,    0,
   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,   25,   25,   25,   25,   25,   25,    4,   25,
   69,    0,    3,    0,  100,    0,   25,    0,    0,    5,
    6,    7,    8,   70,   10,   11,    0,   13,   71,   73,
   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   72,  134,
    0,    0,    0,    0,    0,    0,    5,    6,    7,    8,
   70,   10,   11,    0,   13,   71,    0,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   72,    4,    0,    2,    0,
    3,    0,    0,    0,    0,    0,   93,   93,    0,    0,
    0,   90,   90,    0,    0,    0,    0,   73,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   93,    0,    0,    0,    0,
   90,   93,    0,    0,    0,    0,   90,   84,   84,   84,
   84,   84,   84,   84,   84,   84,    0,   84,   84,   84,
   84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
   84,   84,   84,   84,   84,    0,   84,    0,    0,    0,
    0,   84,    0,   84,   83,   83,   83,   83,   83,   83,
   83,   83,   83,    0,   83,   83,   83,   83,   83,   83,
   83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
   83,   83,    0,   83,    0,    0,    0,    0,   83,    0,
   83,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    5,    6,
    7,    8,   70,   10,   11,    0,   13,   71,    0,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   72,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   92,    7,    8,
   70,   10,   11,    0,   13,   71,    0,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    5,    6,    7,    8,
   70,   10,   11,    0,   13,   71,    0,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   92,    7,    8,   70,   10,
   11,   12,   13,   14,    0,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,   92,    7,    8,   70,   10,
   11,  113,   13,   71,    0,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,  144,   92,    7,    8,
   70,   10,   11,   12,   13,   14,    0,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,   85,    5,    6,    7,
    8,   70,   10,   11,    0,   13,   71,    0,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   92,    7,    8,   70,
   10,   11,   12,   13,   14,    0,   15,   16,   17,   18,
   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   92,    7,    8,   70,   10,   11,
    0,   13,   71,    0,   15,   16,   17,   18,   19,   20,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,
};
short yycheck[] = {                                      38,
   36,   40,   41,   42,    0,   44,    3,   82,   40,   44,
   40,    4,    2,   41,   47,    0,   44,  260,   41,  292,
   59,   44,   61,  265,   59,   36,  294,   63,  258,  259,
   38,  293,   40,   69,   42,  110,   41,   41,   38,   44,
   40,   41,   42,  286,   44,   61,   36,   80,   66,   41,
  294,   59,   44,   46,   42,   51,  289,   50,  288,   59,
   59,  258,  259,   81,  288,  101,   51,   64,   44,   41,
   41,   38,   57,   40,   38,   42,   40,   41,   42,   69,
   44,   44,   93,   59,   69,   50,   97,  288,   41,   82,
  101,  109,   41,   44,  288,   59,  291,   82,  116,   41,
  289,   66,   59,   44,  289,    0,   38,   97,   40,  293,
   38,  101,   40,    0,   42,  288,   41,  107,   41,  288,
   41,   86,   59,   59,   89,  110,  107,   51,   80,   69,
  109,   59,   -1,   -1,  130,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  130,   38,  140,   40,   -1,
   42,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  152,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   38,   -1,   40,   41,   42,   -1,   44,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,   -1,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  258,   38,   -1,   40,  293,  287,  295,  287,  258,  259,
  260,  261,  262,  263,  264,  293,  266,  267,   -1,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  293,   -1,
  289,  258,  259,  293,  258,  259,  260,  261,  262,  263,
  264,  293,  266,  267,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,   -1,   44,  258,  259,  256,  293,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
   59,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,   38,
   -1,   40,   41,   42,   -1,  293,  258,  259,  260,  261,
  262,  263,  264,   -1,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,   38,   -1,   40,   -1,
   42,  293,  258,  259,  260,  261,  262,  263,  264,   -1,
  266,  267,   -1,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  258,  259,   -1,   -1,   38,  293,   40,   41,
   42,   38,   44,   40,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  287,   -1,   -1,   -1,   -1,   -1,  293,   -1,   -1,
   -1,  258,  259,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   61,
  287,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   61,   -1,   -1,   -1,
  259,  260,  261,  262,  263,  264,  265,  266,  267,   -1,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   38,  288,
   40,   -1,   42,   -1,  293,   -1,  295,   -1,   -1,  258,
  259,  260,  261,  262,  263,  264,   -1,  266,  267,   59,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,   41,
   -1,   -1,   -1,   -1,   -1,   -1,  258,  259,  260,  261,
  262,  263,  264,   -1,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,   38,   -1,   40,   -1,
   42,   -1,   -1,   -1,   -1,   -1,  258,  259,   -1,   -1,
   -1,  258,  259,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  287,   -1,   -1,   -1,   -1,
  287,  293,   -1,   -1,   -1,   -1,  293,  259,  260,  261,
  262,  263,  264,  265,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,   -1,   -1,   -1,
   -1,  293,   -1,  295,  259,  260,  261,  262,  263,  264,
  265,  266,  267,   -1,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,   -1,  288,   -1,   -1,   -1,   -1,  293,   -1,
  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  258,  259,
  260,  261,  262,  263,  264,   -1,  266,  267,   -1,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  259,  260,  261,
  262,  263,  264,   -1,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  258,  259,  260,  261,
  262,  263,  264,   -1,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  259,  260,  261,  262,  263,
  264,  265,  266,  267,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   -1,   -1,  259,  260,  261,  262,  263,
  264,  295,  266,  267,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   -1,   -1,   -1,  290,  259,  260,  261,
  262,  263,  264,  265,  266,  267,   -1,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,   -1,  288,  258,  259,  260,
  261,  262,  263,  264,   -1,  266,  267,   -1,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  259,  260,  261,  262,
  263,  264,  265,  266,  267,   -1,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  259,  260,  261,  262,  263,  264,
   -1,  266,  267,   -1,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,
};
#define YYFINAL 35
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 295
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'&'",0,"'('","')'","'*'",0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,
"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"STD_TYPENAME","T_IDENTIFIER","T_TYPEDEF_NAME","T_DEFINE_NAME","T_AUTO",
"T_EXTERN","T_REGISTER","T_STATIC","T_TYPEDEF","T_INLINE","T_EXTENSION",
"T_ATTRIBUTE","T_CHAR","T_DOUBLE","T_FLOAT","T_INT","T_VOID","T_LONG","T_SHORT",
"T_SIGNED","T_UNSIGNED","T_ENUM","T_STRUCT","T_UNION","T_Bool","T_Complex",
"T_Imaginary","T_LONG_DOUBLE","T_VA_LIST","T_TYPE_QUALIFIER","T_BRACKETS",
"T_LBRACE","T_MATCHRBRACE","T_ELLIPSIS","T_INITIALIZER","T_STRING_LITERAL",
"T_ASM","T_ASMARG","T_VA_DCL",
};
char *yyrule[] = {
"$accept : program",
"program :",
"program : translation_unit",
"translation_unit : external_declaration",
"translation_unit : translation_unit external_declaration",
"external_declaration : declaration",
"external_declaration : function_definition",
"external_declaration : ';'",
"external_declaration : linkage_specification",
"external_declaration : asm_specifier",
"external_declaration : error T_MATCHRBRACE",
"external_declaration : error ';'",
"braces : T_LBRACE T_MATCHRBRACE",
"linkage_specification : T_EXTERN T_STRING_LITERAL braces",
"linkage_specification : T_EXTERN T_STRING_LITERAL declaration",
"declaration : decl_specifiers ';'",
"declaration : decl_specifiers init_declarator_list ';'",
"$$1 :",
"declaration : any_typedef decl_specifiers $$1 opt_declarator_list ';'",
"any_typedef : T_EXTENSION T_TYPEDEF",
"any_typedef : T_TYPEDEF",
"opt_declarator_list :",
"opt_declarator_list : declarator_list",
"declarator_list : declarator",
"declarator_list : declarator_list ',' declarator",
"$$2 :",
"$$3 :",
"function_definition : decl_specifiers declarator $$2 opt_declaration_list T_LBRACE $$3 T_MATCHRBRACE",
"$$4 :",
"function_definition : declarator $$4 opt_declaration_list T_LBRACE T_MATCHRBRACE",
"opt_declaration_list :",
"opt_declaration_list : T_VA_DCL",
"opt_declaration_list : declaration_list",
"declaration_list : declaration",
"declaration_list : declaration_list declaration",
"decl_specifiers : decl_specifier",
"decl_specifiers : decl_specifiers decl_specifier",
"decl_specifier : storage_class",
"decl_specifier : type_specifier",
"decl_specifier : type_qualifier",
"storage_class : T_AUTO",
"storage_class : T_EXTERN",
"storage_class : T_REGISTER",
"storage_class : T_STATIC",
"storage_class : T_INLINE",
"storage_class : T_EXTENSION",
"type_specifier : T_CHAR",
"type_specifier : T_DOUBLE",
"type_specifier : T_LONG_DOUBLE",
"type_specifier : T_FLOAT",
"type_specifier : T_INT",
"type_specifier : T_LONG",
"type_specifier : T_SHORT",
"type_specifier : T_SIGNED",
"type_specifier : T_UNSIGNED",
"type_specifier : T_VA_LIST",
"type_specifier : T_VOID",
"type_specifier : T_Bool",
"type_specifier : T_Complex",
"type_specifier : T_Imaginary",
"type_specifier : T_TYPEDEF_NAME",
"type_specifier : struct_or_union_specifier",
"type_specifier : enum_specifier",
"type_qualifier : T_TYPE_QUALIFIER",
"type_qualifier : T_DEFINE_NAME",
"struct_or_union_specifier : struct_or_union any_id braces",
"struct_or_union_specifier : struct_or_union braces",
"struct_or_union_specifier : struct_or_union any_id",
"struct_or_union : T_STRUCT",
"struct_or_union : T_UNION",
"init_declarator_list : init_declarator",
"init_declarator_list : init_declarator_list ',' init_declarator",
"init_declarator : declarator",
"$$5 :",
"init_declarator : declarator '=' $$5 T_INITIALIZER",
"asm_specifier : T_ASM T_ASMARG",
"asm_specifier : parameter_declaration T_ASM T_ASMARG",
"enum_specifier : enumeration any_id braces",
"enum_specifier : enumeration braces",
"enum_specifier : enumeration any_id",
"enumeration : T_ENUM",
"any_id : T_IDENTIFIER",
"any_id : T_TYPEDEF_NAME",
"declarator : pointer direct_declarator",
"declarator : direct_declarator",
"direct_declarator : identifier_or_ref",
"direct_declarator : '(' declarator ')'",
"direct_declarator : direct_declarator T_BRACKETS",
"direct_declarator : direct_declarator '(' parameter_type_list ')'",
"direct_declarator : direct_declarator '(' opt_identifier_list ')'",
"pointer : '*' opt_type_qualifiers",
"pointer : '*' opt_type_qualifiers pointer",
"opt_type_qualifiers :",
"opt_type_qualifiers : type_qualifier_list",
"type_qualifier_list : type_qualifier",
"type_qualifier_list : type_qualifier_list type_qualifier",
"parameter_type_list : parameter_list",
"parameter_type_list : parameter_list ',' T_ELLIPSIS",
"parameter_list : parameter_declaration",
"parameter_list : parameter_list ',' parameter_declaration",
"parameter_declaration : decl_specifiers declarator",
"parameter_declaration : decl_specifiers abs_declarator",
"parameter_declaration : decl_specifiers",
"opt_identifier_list :",
"opt_identifier_list : identifier_list",
"identifier_list : any_id",
"identifier_list : identifier_list ',' any_id",
"identifier_or_ref : any_id",
"identifier_or_ref : '&' any_id",
"abs_declarator : pointer",
"abs_declarator : pointer direct_abs_declarator",
"abs_declarator : direct_abs_declarator",
"direct_abs_declarator : '(' abs_declarator ')'",
"direct_abs_declarator : direct_abs_declarator T_BRACKETS",
"direct_abs_declarator : T_BRACKETS",
"direct_abs_declarator : direct_abs_declarator '(' parameter_type_list ')'",
"direct_abs_declarator : direct_abs_declarator '(' ')'",
"direct_abs_declarator : '(' parameter_type_list ')'",
"direct_abs_declarator : '(' ')'",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 882 "./grammar.y"

#include "keywords.c"

#if defined(HAVE_CONFIG_H)
# include "lex.yy.c"
#else
#if defined(__EMX__) || defined(MSDOS) || defined(OS2) || defined(WIN32) || defined(vms)
# ifdef USE_flex
#  include "lexyy.c"
# else
#  include "lex_yy.c"
# endif
#else
# include "lex.yy.c"
#endif
#endif

static void
yaccError(const char *msg)
{
    func_params = NULL;
    put_error();		/* tell what line we're on, and what file */
    fprintf(stderr, "%s at token '%s'\n", msg, yytext);
}

/* Initialize the table of type qualifier keywords recognized by the lexical
 * analyzer.
 */
void
init_parser(void)
{
    static const char *keywords[] =
    {
	"const",
	"restrict",
	"volatile",
	"interrupt",
#ifdef vms
	"noshare",
	"readonly",
#endif
#if defined(MSDOS) || defined(OS2)
	"__cdecl",
	"__export",
	"__far",
	"__fastcall",
	"__fortran",
	"__huge",
	"__inline",
	"__interrupt",
	"__loadds",
	"__near",
	"__pascal",
	"__saveregs",
	"__segment",
	"__stdcall",
	"__syscall",
	"_cdecl",
	"_cs",
	"_ds",
	"_es",
	"_export",
	"_far",
	"_fastcall",
	"_fortran",
	"_huge",
	"_interrupt",
	"_loadds",
	"_near",
	"_pascal",
	"_saveregs",
	"_seg",
	"_segment",
	"_ss",
	"cdecl",
	"far",
	"huge",
	"near",
	"pascal",
#ifdef OS2
	"__far16",
#endif
#endif
#ifdef __GNUC__
    /* gcc aliases */
	"__builtin_va_arg",
	"__builtin_va_list",
	"__const",
	"__const__",
	"__gnuc_va_list",
	"__inline",
	"__inline__",
	"__restrict",
	"__restrict__",
	"__volatile",
	"__volatile__",
#endif
#ifdef __FreeBSD__
	"_Noreturn",
	"_Thread_local",
#endif
    };
    unsigned i;

    /* Initialize type qualifier table. */
    type_qualifiers = new_symbol_table();
    for (i = 0; i < sizeof(keywords) / sizeof(keywords[0]); ++i) {
	new_symbol(type_qualifiers, keywords[i], NULL, DS_NONE);
    }
}

#ifdef DEBUG_YYIN
static FILE *
copyfile(FILE *input, const char *name)
{
    FILE *output;
    char my_filename[1024];
    int n;
    int ch;
    for (n = 0; n < 999; ++n) {
	sprintf(my_filename, "%s.gen%03d", name, n);
	if ((output = fopen(my_filename, "r")) != 0) {
	    fclose(output);
	} else {
	    break;
	}
    }
    if ((output = fopen(my_filename, "w")) != 0) {
	while ((ch = fgetc(input)) != EOF) {
	    if (ferror(input))
		break;
	    fputc(ch, output);
	}
	fclose(output);
    }
    return fopen(my_filename, "r");
}
#endif /* DEBUG_YYIN */

/* Process the C source file.  Write function prototypes to the standard
 * output.  Convert function definitions and write the converted source
 * code to a temporary file.
 */
void
process_file(FILE *infile, const char *name)
{
    const char *s;

    if (strlen(name) > 2) {
	s = name + strlen(name) - 2;
	if (*s == '.') {
	    ++s;
	    if (*s == 'l' || *s == 'y')
		BEGIN LEXYACC;
#if defined(MSDOS) || defined(OS2)
	    if (*s == 'L' || *s == 'Y')
		BEGIN LEXYACC;
#endif
	}
    }

    /* *INDENT-EQLS* */
    define_names   = new_symbol_table();
    function_names = new_symbol_table();
    included_files = new_symbol_table();
    typedef_names  = new_symbol_table();
    inc_depth      = -1;
    curly          = 0;
    ly_count       = 0;
    func_params    = NULL;

#ifdef DEBUG_YYIN
    yyin = copyfile(infile, name);
#else
    yyin = infile;
#endif
    include_file(strcpy(base_file, name), func_style != FUNC_NONE);
    if (file_comments) {
#if OPT_LINTLIBRARY
	if (lintLibrary()) {
	    put_blankline(stdout);
	    begin_tracking();
	}
#endif
	put_string(stdout, "/* ");
	put_string(stdout, cur_file_name());
	put_string(stdout, " */\n");
    }
    yyparse();

    /* *INDENT-EQLS* */
    define_names   = free_symbol_table(define_names);
    function_names = free_symbol_table(function_names);
    included_files = free_symbol_table(included_files);
    typedef_names  = free_symbol_table(typedef_names);
}

#ifdef NO_LEAKS
void
free_parser(void)
{
    free_symbol_table(type_qualifiers);
#ifdef FLEX_SCANNER
    if (yy_current_buffer != 0)
	yy_delete_buffer(yy_current_buffer);
#endif
    if (temp_buf != 0) {
	temp_buf = 0;
	temp_len = 0;
    }
}
#endif
#line 847 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 10:
#line 192 "./grammar.y"
{
	    yyerrok;
	}
break;
case 11:
#line 196 "./grammar.y"
{
	    yyerrok;
	}
break;
case 13:
#line 207 "./grammar.y"
{
	    /* Provide an empty action here so bison will not complain about
	     * incompatible types in the default action it normally would
	     * have generated.
	     */
	}
break;
case 14:
#line 214 "./grammar.y"
{
	    /* empty */
	}
break;
case 15:
#line 221 "./grammar.y"
{
#if OPT_LINTLIBRARY
	    if (types_out && want_typedef()) {
		gen_declarations(&yyvsp[-1].decl_spec, (DeclaratorList *)0);
		flush_varargs();
	    }
#endif
	    free_decl_spec(&yyvsp[-1].decl_spec);
	    end_typedef();
	}
break;
case 16:
#line 232 "./grammar.y"
{
	    if (func_params != NULL) {
		set_param_types(func_params, &yyvsp[-2].decl_spec, &yyvsp[-1].decl_list);
	    } else {
		gen_declarations(&yyvsp[-2].decl_spec, &yyvsp[-1].decl_list);
#if OPT_LINTLIBRARY
		flush_varargs();
#endif
		free_decl_list(&yyvsp[-1].decl_list);
	    }
	    free_decl_spec(&yyvsp[-2].decl_spec);
	    end_typedef();
	}
break;
case 17:
#line 246 "./grammar.y"
{
	    cur_decl_spec_flags = (int) yyvsp[0].decl_spec.flags;
	    free_decl_spec(&yyvsp[0].decl_spec);
	}
break;
case 18:
#line 251 "./grammar.y"
{
	    end_typedef();
	}
break;
case 19:
#line 258 "./grammar.y"
{
	    begin_typedef();
	}
break;
case 20:
#line 262 "./grammar.y"
{
	    begin_typedef();
	}
break;
case 23:
#line 274 "./grammar.y"
{
	    int flags = cur_decl_spec_flags;

	    /* If the typedef is a pointer type, then reset the short type
	     * flags so it does not get promoted.
	     */
	    if (strcmp(yyvsp[0].declarator->text, yyvsp[0].declarator->name) != 0)
		flags &= (int) ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, yyvsp[0].declarator->name, NULL, flags);
	    free_declarator(yyvsp[0].declarator);
	}
break;
case 24:
#line 286 "./grammar.y"
{
	    int flags = cur_decl_spec_flags;

	    if (strcmp(yyvsp[0].declarator->text, yyvsp[0].declarator->name) != 0)
		flags &= (int) ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, yyvsp[0].declarator->name, NULL, flags);
	    free_declarator(yyvsp[0].declarator);
	}
break;
case 25:
#line 298 "./grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    if (yyvsp[0].declarator->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &(yyvsp[0].declarator->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
break;
case 26:
#line 309 "./grammar.y"
{
	    /* If we're converting to K&R and we've got a nominally K&R
	     * function which has a parameter which is ANSI (i.e., a prototyped
	     * function pointer), then we must override the deciphered value of
	     * 'func_def' so that the parameter will be converted.
	     */
	    if (func_style == FUNC_TRADITIONAL
	     && haveAnsiParam()
	     && yyvsp[-3].declarator->head->func_def == func_style) {
		yyvsp[-3].declarator->head->func_def = FUNC_BOTH;
	    }

	    func_params = NULL;

	    if (cur_file->convert)
		gen_func_definition(&yyvsp[-4].decl_spec, yyvsp[-3].declarator);
	    gen_prototype(&yyvsp[-4].decl_spec, yyvsp[-3].declarator);
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&yyvsp[-4].decl_spec);
	    free_declarator(yyvsp[-3].declarator);
	}
break;
case 28:
#line 334 "./grammar.y"
{
	    if (yyvsp[0].declarator->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &(yyvsp[0].declarator->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
break;
case 29:
#line 344 "./grammar.y"
{
	    DeclSpec decl_spec;

	    func_params = NULL;

	    new_decl_spec(&decl_spec, dft_decl_spec(), yyvsp[-4].declarator->begin, DS_NONE);
	    if (cur_file->convert)
		gen_func_definition(&decl_spec, yyvsp[-4].declarator);
	    gen_prototype(&decl_spec, yyvsp[-4].declarator);
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&decl_spec);
	    free_declarator(yyvsp[-4].declarator);
	}
break;
case 36:
#line 375 "./grammar.y"
{
	    join_decl_specs(&yyval.decl_spec, &yyvsp[-1].decl_spec, &yyvsp[0].decl_spec);
	    free_decl_spec(&yyvsp[-1].decl_spec);
	    free_decl_spec(&yyvsp[0].decl_spec);
	}
break;
case 40:
#line 390 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 41:
#line 394 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_EXTERN);
	}
break;
case 42:
#line 398 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 43:
#line 402 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_STATIC);
	}
break;
case 44:
#line 406 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_INLINE);
	}
break;
case 45:
#line 410 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_JUNK);
	}
break;
case 46:
#line 417 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_CHAR);
	}
break;
case 47:
#line 421 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 48:
#line 425 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 49:
#line 429 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_FLOAT);
	}
break;
case 50:
#line 433 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 51:
#line 437 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 52:
#line 441 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_SHORT);
	}
break;
case 53:
#line 445 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 54:
#line 449 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 55:
#line 453 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 56:
#line 457 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 57:
#line 461 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_CHAR);
	}
break;
case 58:
#line 465 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_UNREAL);
	}
break;
case 59:
#line 469 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_UNREAL);
	}
break;
case 60:
#line 473 "./grammar.y"
{
	    Symbol *s;
	    s = find_symbol(typedef_names, yyvsp[0].text.text);
	    if (s != NULL)
		new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, s->flags);
	}
break;
case 63:
#line 485 "./grammar.y"
{
	    new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, DS_NONE);
	}
break;
case 64:
#line 489 "./grammar.y"
{
	    /* This rule allows the <pointer> nonterminal to scan #define
	     * names as if they were type modifiers.
	     */
	    Symbol *s;
	    s = find_symbol(define_names, yyvsp[0].text.text);
	    if (s != NULL)
		new_decl_spec(&yyval.decl_spec, yyvsp[0].text.text, yyvsp[0].text.begin, s->flags);
	}
break;
case 65:
#line 502 "./grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(2 + strlen(yyvsp[-2].text.text) + strlen(yyvsp[-1].text.text));
	        (void)sprintf(s = temp_buf, "%s %s", yyvsp[-2].text.text, yyvsp[-1].text.text);
	    }
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-2].text.begin, DS_NONE);
	}
break;
case 66:
#line 511 "./grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen(yyvsp[-1].text.text));
		(void)sprintf(s = temp_buf, "%s {}", yyvsp[-1].text.text);
	    }
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 67:
#line 520 "./grammar.y"
{
	    need_temp(2 + strlen(yyvsp[-1].text.text) + strlen(yyvsp[0].text.text));
	    (void)sprintf(temp_buf, "%s %s", yyvsp[-1].text.text, yyvsp[0].text.text);
	    new_decl_spec(&yyval.decl_spec, temp_buf, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 68:
#line 529 "./grammar.y"
{
	    imply_typedef(yyval.text.text);
	}
break;
case 69:
#line 533 "./grammar.y"
{
	    imply_typedef(yyval.text.text);
	}
break;
case 70:
#line 540 "./grammar.y"
{
	    new_decl_list(&yyval.decl_list, yyvsp[0].declarator);
	}
break;
case 71:
#line 544 "./grammar.y"
{
	    add_decl_list(&yyval.decl_list, &yyvsp[-2].decl_list, yyvsp[0].declarator);
	}
break;
case 72:
#line 551 "./grammar.y"
{
	    if (yyvsp[0].declarator->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator(yyvsp[0].declarator);
		fputs(cur_text(), cur_file->tmp_file);
	    }
	    cur_declarator = yyval.declarator;
	}
break;
case 73:
#line 560 "./grammar.y"
{
	    if (yyvsp[-1].declarator->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator(yyvsp[-1].declarator);
		fputs(" =", cur_file->tmp_file);
	    }
	}
break;
case 76:
#line 573 "./grammar.y"
{
	    free_parameter(yyvsp[-2].parameter);
	}
break;
case 77:
#line 580 "./grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(6 + strlen(yyvsp[-1].text.text));
		(void)sprintf(s = temp_buf, "enum %s", yyvsp[-1].text.text);
	    }
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-2].text.begin, DS_NONE);
	}
break;
case 78:
#line 589 "./grammar.y"
{
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen(yyvsp[-1].text.text));
		(void)sprintf(s = temp_buf, "%s {}", yyvsp[-1].text.text);
	    }
	    new_decl_spec(&yyval.decl_spec, s, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 79:
#line 598 "./grammar.y"
{
	    need_temp(6 + strlen(yyvsp[0].text.text));
	    (void)sprintf(temp_buf, "enum %s", yyvsp[0].text.text);
	    new_decl_spec(&yyval.decl_spec, temp_buf, yyvsp[-1].text.begin, DS_NONE);
	}
break;
case 80:
#line 607 "./grammar.y"
{
	    imply_typedef("enum");
	    yyval.text = yyvsp[0].text;
	}
break;
case 83:
#line 620 "./grammar.y"
{
	    yyval.declarator = yyvsp[0].declarator;

	    need_temp(1 + strlen(yyvsp[-1].text.text) + strlen(yyvsp[0].declarator->text));
	    (void)sprintf(temp_buf, "%s%s", yyvsp[-1].text.text, yyval.declarator->text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	    yyval.declarator->begin = yyvsp[-1].text.begin;
	    yyval.declarator->pointer = TRUE;
	}
break;
case 85:
#line 636 "./grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, yyvsp[0].text.text, yyvsp[0].text.begin);
	}
break;
case 86:
#line 640 "./grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;

	    need_temp(2 + strlen(yyvsp[-1].declarator->text));
	    (void)sprintf(temp_buf, "(%s)", yyval.declarator->text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	    yyval.declarator->begin = yyvsp[-2].text.begin;
	}
break;
case 87:
#line 651 "./grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;

	    need_temp(1 + strlen(yyvsp[-1].declarator->text) + strlen(yyvsp[0].text.text));
	    (void)sprintf(temp_buf, "%s%s", yyval.declarator->text, yyvsp[0].text.text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	}
break;
case 88:
#line 661 "./grammar.y"
{
	    yyval.declarator = new_declarator("%s()", yyvsp[-3].declarator->name, yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 89:
#line 669 "./grammar.y"
{
	    yyval.declarator = new_declarator("%s()", yyvsp[-3].declarator->name, yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_TRADITIONAL;
	}
break;
case 90:
#line 680 "./grammar.y"
{
	    need_temp(2 + strlen(yyvsp[0].text.text));
	    (void)sprintf(yyval.text.text, "*%.*s", MAX_TEXT_SIZE - 2, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	}
break;
case 91:
#line 686 "./grammar.y"
{
	    need_temp(2 + strlen(yyvsp[-1].text.text) + strlen(yyvsp[0].text.text));
	    (void)sprintf(yyval.text.text, "*%.*s%.*s",
			  (MAX_TEXT_SIZE / 2) - 2, yyvsp[-1].text.text,
			  (MAX_TEXT_SIZE / 2) - 2, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-2].text.begin;
	}
break;
case 92:
#line 697 "./grammar.y"
{
	    strcpy(yyval.text.text, "");
	    yyval.text.begin = 0L;
	}
break;
case 94:
#line 706 "./grammar.y"
{
	    need_temp(2 + strlen(yyvsp[0].decl_spec.text));
	    (void)sprintf(yyval.text.text, "%s ", yyvsp[0].decl_spec.text);
	    yyval.text.begin = yyvsp[0].decl_spec.begin;
	    free(yyvsp[0].decl_spec.text);
	}
break;
case 95:
#line 713 "./grammar.y"
{
	    need_temp(1 + strlen(yyvsp[-1].text.text) + strlen(yyvsp[0].decl_spec.text));
	    (void)sprintf(yyval.text.text, "%.*s%.*s ",
			  (MAX_TEXT_SIZE / 2) - 2, yyvsp[-1].text.text,
			  (MAX_TEXT_SIZE / 2) - 2, yyvsp[0].decl_spec.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	    free(yyvsp[0].decl_spec.text);
	}
break;
case 97:
#line 726 "./grammar.y"
{
	    add_ident_list(&yyval.param_list, &yyvsp[-2].param_list, "...");
	}
break;
case 98:
#line 733 "./grammar.y"
{
	    new_param_list(&yyval.param_list, yyvsp[0].parameter);
	}
break;
case 99:
#line 737 "./grammar.y"
{
	    add_param_list(&yyval.param_list, &yyvsp[-2].param_list, yyvsp[0].parameter);
	}
break;
case 100:
#line 744 "./grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[-1].decl_spec, yyvsp[0].declarator);
	}
break;
case 101:
#line 749 "./grammar.y"
{
	    check_untagged(&yyvsp[-1].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[-1].decl_spec, yyvsp[0].declarator);
	}
break;
case 102:
#line 754 "./grammar.y"
{
	    check_untagged(&yyvsp[0].decl_spec);
	    yyval.parameter = new_parameter(&yyvsp[0].decl_spec, (Declarator *)0);
	}
break;
case 103:
#line 762 "./grammar.y"
{
	    new_ident_list(&yyval.param_list);
	}
break;
case 105:
#line 770 "./grammar.y"
{
	    new_ident_list(&yyval.param_list);
	    add_ident_list(&yyval.param_list, &yyval.param_list, yyvsp[0].text.text);
	}
break;
case 106:
#line 775 "./grammar.y"
{
	    add_ident_list(&yyval.param_list, &yyvsp[-2].param_list, yyvsp[0].text.text);
	}
break;
case 107:
#line 782 "./grammar.y"
{
	    yyval.text = yyvsp[0].text;
	}
break;
case 108:
#line 786 "./grammar.y"
{
	    need_temp(2 + strlen(yyvsp[0].text.text));
#if OPT_LINTLIBRARY
	    if (lintLibrary()) { /* Lint doesn't grok C++ ref variables */
		yyval.text = yyvsp[0].text;
	    } else
#endif
		(void)sprintf(yyval.text.text, "&%.*s", MAX_TEXT_SIZE - 2, yyvsp[0].text.text);
	    yyval.text.begin = yyvsp[-1].text.begin;
	}
break;
case 109:
#line 800 "./grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, "", yyvsp[0].text.begin);
	}
break;
case 110:
#line 804 "./grammar.y"
{
	    yyval.declarator = yyvsp[0].declarator;

	    need_temp(1 + strlen(yyvsp[-1].text.text) + strlen(yyvsp[0].declarator->text));
	    (void)sprintf(temp_buf, "%s%s", yyvsp[-1].text.text, yyval.declarator->text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	    yyval.declarator->begin = yyvsp[-1].text.begin;
	}
break;
case 112:
#line 819 "./grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;

	    need_temp(3 + strlen(yyvsp[-1].declarator->text));
	    (void)sprintf(temp_buf, "(%s)", yyval.declarator->text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	    yyval.declarator->begin = yyvsp[-2].text.begin;
	}
break;
case 113:
#line 830 "./grammar.y"
{
	    yyval.declarator = yyvsp[-1].declarator;

	    need_temp(1 + strlen(yyvsp[-1].declarator->text) + strlen(yyvsp[0].text.text));
	    (void)sprintf(temp_buf, "%s%s", yyval.declarator->text, yyvsp[0].text.text);

	    free(yyval.declarator->text);
	    yyval.declarator->text = xstrdup(temp_buf);
	}
break;
case 114:
#line 840 "./grammar.y"
{
	    yyval.declarator = new_declarator(yyvsp[0].text.text, "", yyvsp[0].text.begin);
	}
break;
case 115:
#line 844 "./grammar.y"
{
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-3].declarator->begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = yyvsp[-3].declarator;
	    yyval.declarator->head = (yyvsp[-3].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-3].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 116:
#line 852 "./grammar.y"
{
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-2].declarator->begin);
	    yyval.declarator->func_stack = yyvsp[-2].declarator;
	    yyval.declarator->head = (yyvsp[-2].declarator->func_stack == NULL) ? yyval.declarator : yyvsp[-2].declarator->head;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 117:
#line 859 "./grammar.y"
{
	    Declarator *d;

	    d = new_declarator("", "", yyvsp[-2].text.begin);
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-2].text.begin);
	    yyval.declarator->params = yyvsp[-1].param_list;
	    yyval.declarator->func_stack = d;
	    yyval.declarator->head = yyval.declarator;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
case 118:
#line 870 "./grammar.y"
{
	    Declarator *d;

	    d = new_declarator("", "", yyvsp[-1].text.begin);
	    yyval.declarator = new_declarator("%s()", "", yyvsp[-1].text.begin);
	    yyval.declarator->func_stack = d;
	    yyval.declarator->head = yyval.declarator;
	    yyval.declarator->func_def = FUNC_ANSI;
	}
break;
#line 1717 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
